/*************************************************************************************/
/* */
/*************************************************************************************/

#define LCD_BASE 0x30FFFF0

static unsigned char* DISPLAYbase= (unsigned char *)LCD_BASE;

static unsigned char* pText="Frydaysoft (c)02\0";

/* 1x16 --> 8+8 Version */
#define LCD_TYPE 0x38


#define Display_Cwr	DISPLAYbase[0]
#define Display_Crd	DISPLAYbase[1]
#define Display_Dwr	DISPLAYbase[2]
#define Display_Drd	DISPLAYbase[3]


#define AT91M		1
#define AT91_PTRS	1
#include "at91xx.h"


#define LEDA	(1<<27)
#define LEDB	(1<<28)
#define LEDC	(1<<29)

#define WAIT   0x40000
#define usWAIT 0x1FFF


#define EBI_CSR3  	ebiCSRbase[3]

/*
Adr16
Adr16
xx.1.0.010.0	xx.CSEN.BAT.TDF.PAGE
0.x.1.001.10	PAGE.x.WSE.NWS.Bus
*/
static int EBI_CSR3_VALUE = 0x03002426;	/* CSEN TDF=2 1MB-Page WSE NWS=2 8Bit*/

/*************************************************************************************/
/* Function prototypes */

void loop();
void leds_on(int leds);
void leds_off(int leds);
void wait(void);
void us_wait(void);

/*************************************************************************************/

StructPIO *at91_pio;


static int* ebiCSRbase= (int *)0xffe00000;

extern int main(void) 
{
	int x,i;

	/* init PIO --> LEDs */
	at91_pio=PIOA_BASE;
	at91_pio->PIO_OER = LEDA | LEDB | LEDC;

	EBI_CSR3=EBI_CSR3_VALUE;


	/*init LCD 8Bit-Mode*/
	for (x=0; x<3; x++)
	{
		Display_Cwr = LCD_TYPE;
		wait();
		wait();
	}

	/* Display & Cursor on */
	Display_Cwr  	= 0x0F;
	us_wait();

	/*clear about 2 ms*/
	Display_Cwr  	= 0x01;
	us_wait();
	us_wait();


	i=0;
	/* write text */
	while(pText[i]!='\0')
	{
		Display_Dwr =(unsigned char)pText[i];
		/*for (x=0; x<3; x++) wait();*/
		i++;
		us_wait();
		/* set cursor to right-part Addr. 0x40 --> 8+8 Version*/
		if(i==8) { Display_Cwr=0xC0; us_wait();}


	}

	/* little cinema */
	loop();
	return(0);
}

/*************************************************************************************/

/* sign per LEDs */
void loop()
{
	at91_pio=PIOA_BASE;

	at91_pio->PIO_OER = LEDA | LEDB | LEDC;

	while(1)
	{
		leds_off(LEDA);
		wait();
		leds_on(LEDA);		

		leds_off(LEDB);
		wait();
		leds_on(LEDB);		

		leds_off(LEDC);
		wait();
		leds_on(LEDC);		
	}
}

/*************************************************************************************/

void leds_on(int leds)
{
	at91_pio->PIO_SODR = leds;
}

/*************************************************************************************/

void leds_off(int leds)
{
	at91_pio->PIO_CODR = leds;
}

/*************************************************************************************/
void us_wait(void)
{
	int n;
	for(n=0;n<usWAIT;n++);
}

/*************************************************************************************/
void wait(void)
{
	int n;
	for(n=0;n<WAIT;n++) ;
}

void __gccmain(){}
