/*************************************************************************************/
/* */
/*************************************************************************************/

#define AT91M		1
#define AT91_PTRS	1
#include "at91xx.h"


#define LED1	(1<<8)
#define LED2	(1<<9)
#define LED3	(1<<10)
#define LED4	(1<<11)
#define LED5	(1<<12)
#define LED6	(1<<13)
#define LED7	(1<<14)
#define LED8	(1<<15)

#define ALL_LEDS LED1|LED2|LED3|LED4|LED5|LED6|LED7|LED8

#define WAIT 0x24000 


/*************************************************************************************/
/* Function prototypes */

void loop();
void leds_on(int leds);
void leds_off(int leds);
void wait(void);

/*************************************************************************************/

StructPIO *at91_pio=PIOB_BASE;

extern int main ( void ) 
{
	at91_pio=PIOB_BASE;
	at91_pio->PIO_IDR  = 0xFFFFFFFF;	/* Disable PIO interrupts */
	at91_pio->PIO_PER  = ALL_LEDS;

	loop();

	return(0);
}

/*************************************************************************************/

/* sign per LEDs */
void loop()
{
	leds_on(ALL_LEDS);		

	while(1)
	{
		leds_off(LED1);
		wait();
		leds_on(ALL_LEDS);		

		leds_off(LED2);
		wait();
		leds_on(ALL_LEDS);
		
		leds_off(LED3);
		wait();
		leds_on(ALL_LEDS);
		
		leds_off(LED4);
		wait();
		leds_on(ALL_LEDS);

		leds_off(LED5);
		wait();
		leds_on(ALL_LEDS);		

		leds_off(LED6);
		wait();
		leds_on(ALL_LEDS);
		
		leds_off(LED7);
		wait();
		leds_on(ALL_LEDS);
		
		leds_off(LED8);
		wait();
		leds_on(ALL_LEDS);
	}
}

/*************************************************************************************/

void leds_on(int leds)
{
	at91_pio->PIO_CODR = leds;
}

/*************************************************************************************/

void leds_off(int leds)
{
	at91_pio->PIO_SODR = leds;
}

/*************************************************************************************/
void wait(void)
{
	int n;
	for(n=0;n<WAIT;n++) {n++;n--;}
}

/*************************************************************************************/
void __gccmain()
{
}
