/* .equ STACK_LIMIT,     0xC00	/* 3K */

/* PIO_A */
.equ GPIOA_BASE , 0xFFFEC000
.equ GPIOB_BASE , 0xFFFF0000

.equ LED1 , 0x04000000
.equ LED2 , 0x08000000
.equ LED3 , 0x10000000
.equ LED4 , 0x20000000

.equ ALL_LEDS , LED1|LED2|LED3|LED4

/* invert LED-pegel */
#define INVERTING_ 

.equ GPDR ,	0x00000010	/* PIO Enable Output */

#ifdef INVERTING
	.equ GPSR ,	0x00000030	/* set */
	.equ GPCR ,	0x00000034	/* clear */
#elsif
	.equ GPSR ,	0x00000034
	.equ GPCR ,	0x00000030
#endif

	.global	__main
__main:	
	.global	__app
__app:
/* ##################################################################### */
	b app
undefvec:	
	b app
swivec:
	b app
pabtvec:
	b app
dabtvec:
	b app
rsvdvec:
	b app
irqvec:
	b app
fiqvec:
	b app

app:
/* ##################################################################### */
	ldr	r0, =GPIOA_BASE
	mov	r1, #0xFFFFFFFF
	str	r1, [r0, #GPDR]		
	mov	r1, #0xFFFFFFFF
	bl 	led_off
	ldr	r0, =GPIOB_BASE
	mov	r1, #0xFFFFFFFF
	str	r1, [r0, #GPDR]		
	mov	r1, #0xFFFFFFFF
	bl 	led_on

ready0:
	mov	r3, #LED1
	bl 	blinkB
	mov	r3, #LED2
	bl 	blinkA
	mov	r3, #LED3
	bl 	blinkA
	mov	r3, #LED4
	bl 	blinkA

	mov	r3, #LED3
	bl 	blinkA
	mov	r3, #LED2
	bl 	blinkA

	b ready0


/* ##################################################################### */
blinkA:
	ldr	r0, =GPIOA_BASE
	b bl
blinkB:
	ldr	r0, =GPIOB_BASE
bl:
	mov r4, lr
	mov	r1,r3
	bl 	led_on
	bl 	asm_wait
	mov	r1,r3
	bl 	led_off
	mov	pc, r4

/* ##################################################################### */
/* turn LED on. clobbers r0 and r1 */
led_on:
	str	r1, [r0, #GPSR]
	mov	pc, lr

/* ##################################################################### */
/* turn LED off. clobbers r0 - r2 */
led_off:
	str	r1, [r0, #GPCR]
	mov	pc, lr

/* ##################################################################### */
/* busy asm_wait loop, clobbers r2*/
.global	asm_shortwait
asm_shortwait:
	mov	r2, #0x80000
	b asm_wait0 
.global	asm_wait
asm_wait:	
	mov	r2, #0x200000
asm_wait0:
	subs	r2, r2, #1
	bne	asm_wait0
	mov	pc, lr
