.equ STACK_LIMIT,     0xC00	/* 3K */
.equ IRQ_STACK_SIZE,  (4*4)

.equ     I_BIT,	0x80
.equ     F_BIT, 0x40
.equ     T_BIT, 0x20

.equ     ARM_MODE_IRQ,  0x12
.equ     ARM_MODE_SYS,  0x1F

.equ	ARM_MODE_USER,  0x10




/* for Mem-Ctrl */
.equ	EBI_BASE,0xFFE00000

/* Adress and CFG NSC0 (Flash) */
/* EB01
.equ EBI_CSR0, 0x01002535
*/

/*EB63*/
.equ EBI_CSR0 ,0x01002529


/* for LCD or PIO_8255 on CS3*/
.equ EBI_CSR3 ,0x03002426


/* Adress and CFG NSC1 (SRAM) */
.equ EBI_CSR1 ,0x02002121

.equ JMP_ADR , 0x2000000



	.global	__main
__main:	
	b	InitReset		/* reset */
undefvec:	
	.long	undefvec		/* Undef */
swivec:
	.long	swivec			/* SW */
pabtvec:
	.long	pabtvec			/* P abt */
dabtvec:
	.long	dabtvec			/* D abt */
rsvdvec:
	.long	rsvdvec			/* reserved */
irqvec:
	/*ldr	pc, [pc,#-0xF20]	/* IRQ : read the AIC */
fiqvec:
	/*ldr	pc, [pc,#-0xF20]	/* FIQ : read the AIC */

InitReset:
	mov	sp,#0x400

SetMode:
	/* Setup the stack for each mode */
	/* Set up Interrupt mode and set IRQ stack */
    	msr         CPSR_c, #ARM_MODE_IRQ|I_BIT|F_BIT
    	mov         r13, #STACK_LIMIT
    	mov         r0, r13
    	sub         r0, r0, #IRQ_STACK_SIZE

	/* Set up the User mode and stack pointer */
    	msr         CPSR_c, #ARM_MODE_SYS|I_BIT|F_BIT /* No interrupts */
    	mov         r13, r0

	/* Setup Application Operating Mode and Enable the interrupts */
    	msr         CPSR_c, #ARM_MODE_USER
    	mov         r13, r0



	ldr	r10, =InitTableEBI	/* get the address of the chip select register image */
	movs	r0, pc, LSR #20		/* pc > 0x100000 */
	moveq	r10, r10, LSL #12	/* Mask the 12 highest bits of the address */
	moveq	r10, r10, LSR #12

	/* Copy Chip Select Register Image to Memory Controller and command remap */
	ldmia	r10!, {r0-r9,r11-r12}	/* load the complete image and the EBI base */
	stmia	r11!, {r0-r9}		/* store the complete image with the remap command */
	mov	pc, r12			/* jump and break the pipeline */


InitTableEBI:
	.long	EBI_CSR0		/* 0x01000000, 16MB, 0 hold, 16 bits, 8 WS */
	.long	EBI_CSR1		/* 0x02000000, 16MB, 0 hold, 16 bits, 1 WS, Byte Select access */
	.long	0x20000000		/* unused */
	.long	EBI_CSR3		/* CS3*/
	.long	0x40000000		/* unused */
	.long	0x50000000		/* unused */
	.long	0x60000000		/* unused */
	.long	0x70000000		/* unused */
	.long	0x00000001		/* REMAP command */
	.long	0x00000006		/* 7 memory regions, standard read */
	.long	EBI_BASE		/* EBI Base address */
	.long	JMP_ADR
